apiVersion: batch/v1
kind: CronJob
metadata:
  name: eclipsefdn-import-backup
  namespace: foundation-internal-webdev-apps
  labels:
    job: github-org-backup
spec:
  schedule: "0 1 * * 0"
  # if it is time for a new job run and the previous job run hasn’t finished yet, the cron job skips the new job run
  concurrencyPolicy: Forbid
  jobTemplate:
    spec:
      # Deadline is 3h
      activeDeadlineSeconds: 21600
      template:
        spec:
          affinity:
            nodeAffinity:
              preferredDuringSchedulingIgnoredDuringExecution:
              - preference:
                  matchExpressions:
                  - key: speed
                    operator: NotIn
                    values:
                    - fast
                weight: 1
          containers:
          - name: eclipsefdn-import-backup
            image: eclipsefdn/eclipsefdn-vc-sync:latest
            imagePullPolicy: IfNotPresent
            args:
            - /bin/sh
            - -c
            - npm run import-backup -- --verbose=true --host="https://gitlab.eclipse.org" --target="264" --tls-min-v1.0 --organization=openhwgroup 2>&1 | tee -a /app/logs/import-stdout-$(date +%Y-%m-%d).log
            volumeMounts:
            - name: logs
              mountPath: /app/logs
            - name: cache
              mountPath: /app/.cache
            - name: import-backup-secrets
              mountPath: "/run/secrets/access-token"
              readOnly: true
              # workaround https://github.com/kubernetes/kubernetes/issues/65835
              subPath: access-token
            - name: import-backup-secrets
              mountPath: "/run/secrets/github-access-token"
              readOnly: true
              # workaround https://github.com/kubernetes/kubernetes/issues/65835
              subPath: github-access-token
          restartPolicy: Never
          volumes:
          - name: logs
            persistentVolumeClaim:
              claimName: import-backup-logs
          - name: cache
            emptyDir: {}
          - name: import-backup-secrets
            secret:
              secretName: import-backup-secrets
              # workaround https://github.com/kubernetes/kubernetes/issues/65835
              items:
              - key: access-token
                path: access-token
              - key: github-access-token
                path: github-access-token
---
apiVersion: v1
kind: PersistentVolume
metadata:
  name: import-backup-logs
spec:
  capacity:
    storage: 10Gi
  accessModes:
    - ReadWriteOnce
  claimRef:
    namespace: foundation-internal-webdev-apps
    name: import-backup-logs
  nfs:
    server: nfsmaster
    path: /opt/export/eclipsefdn-import-backup/logs
  mountOptions:
    - vers=4.2
    - rw
    - proto=tcp
    - rsize=32768
    - wsize=32768
    - timeo=600
    - fg
    - hard
    - retrans=10
    - intr
    - relatime
    - nodiratime
    - async
---
kind: PersistentVolumeClaim
apiVersion: v1
metadata:
  name: import-backup-logs
  namespace: foundation-internal-webdev-apps
spec:
  accessModes:
    - ReadWriteOnce
  resources:
    requests:
      storage: 10Gi
